<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
// $webp_name doit être identique au nom de la base de données !!!
//$webp_model='model_'.$webp_name.'.php';
//Inclusion des librairie
include_once $path.'common.php';

if(strpos($licence['type'],'LITE')!==FALSE)
{
    $smarty->assign('need_licence','Heimdall, Mercury');
    $smarty->display('no_licence.html');
    exit(0);

}

include_once 'inc/control/common.php';
include_once $path.'/libs/php/convert.lib.php';

$webp_name='WEBP_HYPERVISOR';
$webp_name_path='virtualization';

$webp_model='model_'.$webp_name_path.'.php';
include_once($path.$apache_plugin_path.$webp_model);

/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
                    'name'=>$node->getName(),
				    'ip'=>$node->getIPAddress(),
				    'id'=>$node->getId(),
				    'description'=>$node->getDescription(),
				    'group'=>$node->getGroup());
 * SMARTY
        $webp_name nom du plugin
        $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */

include_once $path.'/inc/common_node_control.php';
include_once $path.$apache_plugin_path."inc/common_lib.php";
session_write_close();

$plugin_template_path = "$path.$apache_plugin_path/templates/";
$error_messages = array();
try{
	if( !is_object($node))
	{
		$node = Model_adm::InstanceNode($dbconnection,$node_id);
	}

	if(	$user->getDroits($dbconnection,"virtualization_access",$node->getName()) !=1
		|| $user->getDroits($dbconnection,"device_view",$node->getName()) !=1
		)
	{
		$smarty->display('no_access.html');
		exit(0);
	}

	$device_type = $node->getType();
	if( $device_type == Model_virtualization::getClusterDeviceType() )
	{
		$virt_type = 'cluster';
	}
	else
	{
		$virt_type = 'hypervisor';
	}

	$auth_params =  Model_virtualization::getAuthenticationParams($dbconnection,$node_id);
	$resources['drv_name'] = $driver = $auth_params['driver'];

    $widget = $_REQUEST['widget'];
    $smarty->assign('widget', $widget);

    $cluster = Model_virtualization::InstantiateDriver($dbconnection,$node_id);

	if($widget=='general')
	{
        //Pour avoir quand mêmes quelques élémentes en cas d'erreurs
        if( $virt_type == 'cluster')
        {
            $host_list_arr = Model_virtualization::getAnotherNodesURL($dbconnection,$node,$virt_type);
            $smarty->assign('host_list',$host_list_arr);
        }
        elseif( $virt_type == 'hypervisor')
        {
            $url_cluster = Model_virtualization::getAnotherNodesURL($dbconnection,$node,$virt_type);
            $resources['page'] = $url_cluster;
        }

        if( $virt_type == 'cluster')
		{
            //Storage
            $sr_type = 'SHARED';
            $storages = $cluster->getStorages(TRUE);
            if( empty($storages))
            {
                $storages = $cluster->getStorages(FALSE);
                $sr_type = 'LOCAL';
            }

            $sr_usage = 0;
            $sr_total = 0;
            foreach($storages as $storage)
            {
                $sr_usage += $storage->getSizeUsed();
                $sr_total += $storage->getSizeTotal();
            }
            $sr = ESIA\Convert\bytesToHuman($sr_usage,$sr_total,0,FALSE);

            $usage = $sr['human']['usage'];
            $total = $sr['human']['total'];
            $unit  = $sr['human']['unit'];
            $resources['sr_percent'] = $sr['percent']['usage'];
            if( $sr_type = 'SHARED')
            {
                $resources['sr_name']    = $lang['VIRT_STORAGES_SHARED'];
            }
            else
            {
                $resources['sr_name']    = $lang['VIRT_STORAGES_LOCAL'];
            }
            $resources['sr_message'] = "$usage $unit / $total $unit";

            //Cluster
			$resources['type'] = $lang['VIRT_TYPE_CLUSTER'];
		    $resources['name'] = $cluster->getName();

			$cpu_usage = round($cluster->getCpusUsage()*100);
			$cpu_total = $cluster->getCpusTotal();

		    $resources['cpu_percent'] = $cpu_usage;
		    $resources['cpu_name']    = 'CPU';
		    $resources['cpu_message'] = "$cpu_usage% / $cpu_total CPU(s)";

			$mem = ESIA\Convert\bytesToHuman($cluster->getMemUsage(),$cluster->getMemTotal(),0,FALSE);
			$usage = $mem['human']['usage'];
			$total = $mem['human']['total'];
			$unit  = $mem['human']['unit'];
		    $resources['ram_percent'] = $mem['percent']['usage'];
		    $resources['ram_name']    = 'RAM';
		    $resources['ram_message'] = "$usage $unit / $total $unit";

            //Host
            $status = "up";
    	    $host_list = $cluster->getHosts();
			foreach($host_list as $host)
			{
				if( !$host->isAlive() )
				{
					$status = "down";
				}
			}
		    $resources['status_value']      = $status;

			if( $cluster->isCluster())
			{
				$resources['clustered_value']   = $lang['VIRT_YES'];
			}
			else
			{
				$resources['clustered_value']   = $lang['VIRT_NO'];
			}

			if( $cluster->isHA())
			{
				$resources['ha_value']   = $lang['VIRT_YES'];
			}
			else
			{
				$resources['ha_value']   = $lang['VIRT_NO'];
			}
        }
        elseif($virt_type == 'hypervisor')
        {
            //Storage
            $storages = $cluster->getStorages(NULL);

            //Host
            $host_list = $cluster->getHosts();
            $nodes_link = Model_virtualization::getClusterNodesLink($dbconnection,$node_id);

            if( count($nodes_link) == 1)
            {
                $nodes_link = array_shift($nodes_link);
                if(isset( $nodes_link['hypervisor_name']))
                {
                    $hypervisorName = $nodes_link['hypervisor_name'];
                }

                $current_host_obj = NULL;
                foreach($host_list as $host){
                    if($host->getName() == $hypervisorName)
                    {
                        $current_host_obj = $host;
                        break;
                    }
                }
            }

            //Storage details
            $sr_usage = 0;
            $sr_total = 0;
            foreach($storages as $storage)
            {
                $hosts = Model_virtualization::objToArray($storage->getHosts(),'name');
                $tmp = array();
                foreach($hosts as $host)
                {
                    $tmp[] = $host['name'];
                }

                if( !in_array($hypervisorName,$tmp))
                {
                    continue;
                }
                $sr_usage += $storage->getSizeUsed();
                $sr_total += $storage->getSizeTotal();
            }
            $sr = ESIA\Convert\bytesToHuman($sr_usage,$sr_total,0,FALSE);

            $usage = $sr['human']['usage'];
            $total = $sr['human']['total'];
            $unit  = $sr['human']['unit'];
            $resources['sr_percent'] = $sr['percent']['usage'];
            $resources['sr_name']    = $lang['VIRT_STORAGES'];
            $resources['sr_message'] = "$usage $unit / $total $unit";


            //Host metrics
            $id = $nodes_link['cluster_id'];
            $page = model_esia::getPageControl($dbconnection,Model_virtualization::getClusterDeviceType());
            //Rempalcer :id par l'id correspondant pour la page de contrôle
            $pattern = "/:id/";
            $urlnode = preg_replace($pattern,$id,$page);
            $resources['page'] = $urlnode;

            $resources['type'] = $lang['VIRT_TYPE_HYPERVISOR'];
            $resources['name'] = $current_host_obj->getName();

            $cpu_usage = round($current_host_obj->getCpusUsage()*100);
            $cpu_total = $current_host_obj->getCpusTotal();

            $resources['cpu_percent'] = $cpu_usage;
            $resources['cpu_name']    = 'CPU';
            $resources['cpu_message'] = "$cpu_usage% / $cpu_total CPU(s)";

            $mem = ESIA\Convert\bytesToHuman($current_host_obj->getMemUsage(),$current_host_obj->getMemTotal(),0,FALSE);
            $usage = $mem['human']['usage'];
            $total = $mem['human']['total'];
            $unit  = $mem['human']['unit'];
            $resources['ram_percent'] = $mem['percent']['usage'];
            $resources['ram_name']    = 'RAM';
            $resources['ram_message'] = "$usage $unit / $total $unit";

            $smarty->assign('current_host',$current_host_arr);
        }
    }
    elseif( $widget=='vm' )
    {
        $vm_list_obj = $cluster->getVMs();
	    $templates = count($cluster->getTemplates());

	    $vm_stats['running']=0;
	    $vm_stats['paused']=0;
	    $vm_stats['stopped']=0;
		$vm_stats['total'] = 0;
	    $vm_stats['locked']=0;
	    $vm_stats['template']= $templates;

	    foreach($vm_list_obj as $vm)
	    {
	        $state = $vm->getState();
	        $vm_stats[$state]++;
	        if( $vm->isLocked() ) $vm_stats['locked']++;
			$vm_stats['total']++;
	    }
	    $smarty->assign('vm_stats',$vm_stats);

        if( $virt_type=='hypervisor' )
        {
            //Host
            $host_list = $cluster->getHosts();
            $nodes_link = Model_virtualization::getClusterNodesLink($dbconnection,$node_id);

            if( count($nodes_link) == 1)
            {
                $nodes_link = array_shift($nodes_link);
                if(isset( $nodes_link['hypervisor_name']))
                {
                    $hypervisorName = $nodes_link['hypervisor_name'];
                }

                $current_host_obj = NULL;
                foreach($host_list as $host){
                    if($host->getName() == $hypervisorName)
                    {
                        $current_host_obj = $host;
                        break;
                    }
                }
            }

            $vm_list_obj = $current_host_obj->getVMs();

            $vm_stats['running']=0;
            $vm_stats['paused']=0;
            $vm_stats['stopped']=0;
            $vm_stats['total'] = 0;
            foreach($vm_list_obj as $vm)
            {
                $state = $vm->getState();
                $vm_stats[$state]++;
                $vm_stats['total']++;
            }
            $smarty->assign('vm_host',$vm_stats);
        }
    }
    elseif( $widget=='hypervisors' )
    {
        $host_list = $cluster->getHosts();
        if( $virt_type == 'cluster')
        {
    	    $host_list_arr = array();
    	    $current_host_arr = NULL;
    	    $current_host_obj = NULL;
    	    foreach($host_list as $host)
    	    {
    			$ret['name'] = $host->getName();
    			$ret['status'] = $host->isAlive();
    			$ret['address'] = $host->getAddress();
    			$ret['cpu_usage'] = round(100*$host->getCpusUsage());
    			$ret['cpu_total'] = $host->getCpusTotal();
    			$ret['cpu_percent'] = $ret['cpu_usage'];
    			$ret['cpu_message'] = $ret['cpu_usage'].'% /' . $ret['cpu_total']. ' CPU(s)';
    			$ret['cpu_status'] = getStatus($ret['cpu_percent']);

    			$mem = ESIA\Convert\bytesToHuman($host->getMemUsage(),$host->getMemTotal(),0,FALSE);
    			$usage = $mem['human']['usage'];
    			$total = $mem['human']['total'];
    			$unit  = $mem['human']['unit'];
    			$ret['mem_usage'] = $usage;
    			$ret['mem_total'] = $total;
    			$ret['mem_unit']  = $unit;
    			$ret['mem_percent'] = $mem['percent']['usage'];
    			$ret['mem_message'] = "$usage $unit / $total $unit";
    			$ret['mem_status'] = getStatus($ret['mem_percent']);
    			$ret['uptime'] = parseUptime($host->getUpTime());
    			$host_list_arr[$ret['name']] = $ret;
    	    }
    	    ksort($host_list_arr,SORT_NATURAL);

            $nodes_link = Model_virtualization::getClusterNodesLink($dbconnection,$node_id);
            $byNodenameLink = array();
            foreach($nodes_link as $row)
            {
            		$byNodenameLink[$row['hypervisor_name']] = $row;
            }

            foreach($host_list_arr as $key => $row)
            {
            		if(isset($byNodenameLink[$row['name']]))
            		{
            				$id = $byNodenameLink[$row['name']]['device_id'];
            				$page = model_esia::getPageControl($dbconnection,Model_virtualization::getHypervisorDeviceType());
            				//Rempalcer :id par l'id correspondant pour la page de contrôle
            				$pattern = "/:id/";
            				$urlnode = preg_replace($pattern,$id,$page);
            				$host_list_arr[$key]['page'] = $urlnode;
            				$host_list_arr[$key]['update'] = "./administration.php?admin=device&amp;action=modif&amp;id=$id";
            		}
            		else
            		{
            				$host_list_arr[$key]['page'] = NULL;

            				$virt_params[]='cluster_id='.$node_id;
            				$virt_params[]='name='.urlencode($row['name']);
            				$virt_params[]='address='.urlencode($row['address']);
            				$host_list_arr[$key]['add'] = "$apache_plugin_path/adv_device_add.php?admin=device&amp;action=create";
            				$host_list_arr[$key]['add'] .= '&' .implode('&',$virt_params);
            		}
            }

            $smarty->assign('host_list',$host_list_arr);
		}
		elseif($virt_type == 'hypervisor')
		{
			$nodes_link = Model_virtualization::getClusterNodesLink($dbconnection,$node_id);
			if( count($nodes_link) == 1)
			{
				$nodes_link = array_shift($nodes_link);
				if(isset( $nodes_link['hypervisor_name']))
				{
					$hypervisorName = $nodes_link['hypervisor_name'];
				}

				$current_host_obj = NULL;
				foreach($host_list as $host)
                {
					if($host->getName() == $hypervisorName)
					{
						$current_host_arr = $host_list_arr[$hypervisorName];
						$current_host_arr['os'] = $host->getOS();

						$netin = $host->getNetInUsage();
						$netin = ESIA\Convert\bitsToHuman($netin,$netin,0,FALSE);
						$netin = $netin['human']['usage'] . ' ' .  $netin['human']['unit'].'/s';

						$netout = $host->getNetOutUsage();
						$netout = ESIA\Convert\bitsToHuman($netout,$netout,0,FALSE);
						$netout = $netout['human']['usage'] . ' ' .  $netout['human']['unit'].'/s';

						$current_host_arr['net_in'] = $netin;
						$current_host_arr['net_out'] = $netout;

                        $current_host_arr['address'] = $host->getAddress();
                        $current_host_arr['uptime'] = parseUptime($host->getUpTime());

						$current_host_obj = $host;
						break;
					}
				}
			}
			$smarty->assign('current_host',$current_host_arr);
		}
	}
}
catch(Exception $ex)
{
	$error_messages[] = $ex->getMessage();
}
$smarty->assign('resources',$resources);
$smarty->assign('error_messages',$error_messages);
$smarty->assign('virt_type',$virt_type);
$smarty->assign('template_path',$plugin_template_path);

$smarty->assign('webplugin_path',$apache_plugin_path);

if( !empty($success_message))
{
	$smarty->assign('success_message',$success_message);
}

$licence = Model_Adm::getLicenceInformation($dbconnection);
$action_licence = (!empty($licence['type']) && strtoupper($licence['type']) == 'MERCURY' );
$action_permit = ($user->getDroits($dbconnection,"virtualization_vm_action",$node->getName()) ==1);
$action_supported = in_array($driver,array('xenserver','proxmox'));
$action_granted = ($action_permit && $action_licence && $action_supported);

$smarty->assign('action_granted',$action_granted);
$smarty->assign('admin_granted',$user->getDroits($dbconnection,"esia_device") == 1);


$smarty->display($plugin_template_path.'display_virtualization.html');

function search_services($name,$arr)
{
	foreach($arr as $service)
	{
		$match ='#'.$name.'#';
		if(preg_match($match,$service['name']))
		{
			return true;
		}
	}
	return false;
}
