//Common functions
function create_scan_table(table_id){
       Utils.createTable("#"+table_id);
       configure_table(table_id);
}

function configure_table(table_id){
        table = $("#"+table_id);//alert("start"+table_id);
        table.data("tablesorter").widgets.push('print');//alert("end"+table_id);
        table.data("tablesorter").widgets.push('columnSelector');
        table.data("tablesorter").widgetOptions['columnSelector_container']=$("#"+table_id+'_columnSelector');

        table.tablesorterPager({
        container: $( "#pager_"+table_id ),
        output: '{startRow} to {endRow} ({filteredRows})',
        size: 100,
    });

        $( '#'+table_id+'_print').on('click', function(){
          table.trigger('printTable');
        });
}

function reload_active_tabs()
{
      var current_index = $("#tabs").tabs("option","active");
      $("#tabs").tabs('load',current_index);
}
//Gestion des onglets
function initTab(css_selector)
{
  $( css_selector ).tabs({
    heightStyle: "content",
    beforeLoad: function( event, ui ) {
        ui.panel.html('<div id="virt_overlay_tab"><div class="loadingGif" style="top:100px;"></div><div class="esiaOverlay"></div></div>');

        let deferred = $.Deferred();
        let timeout =  setTimeout(function() {
            ui.jqXHR.abort(); // Annule la requête AJAX
            deferred.reject("timeout", "Request timeout");
        }, 30000);

        ui.jqXHR.done(function(result) {
             clearTimeout(timeout);
        }).fail(function(jqXHR, textStatus, errorThrown) {
          clearTimeout(timeout); // Annule le timeout si la requête échoue
          deferred.reject(textStatus, errorThrown); // Annule tout si la requête échoue
        });

        deferred.done(function(result) {
          ui.panel.html(result);
        }).fail(function(textStatus, errorThrown) {
          ui.panel.html('<div class="EventCritical"><p>Error - '+ errorThrown+'</p></div>');
        });
    },
   // active: activate,
    load: function (event, ui){
    if(ui.panel.find("#page_login_detect").length > 0) location.reload();
  },
  });
}

//Page Etat des services
function virt_widget_ajax_load(id,url,callback)
{
    $(id).find('.loadingGif').css('top','calc(50% - 75px)');
    $(id).find('.esiaOverlay' ).css('background','#FFFFFF')
    $(id).find('.esiaOverlay-container' ).show();
    $(id).find('.progressbar' ).progressbar({value: false});

    $.ajax({
        type: "GET",
        url: url,
        dataType: "html"
    }).done(function(data){
        $(id+' .esiaOverlay-container').hide();
        $(id).html(data);

        // Exécuter le callback supplémentaire s'il est défini
        if (typeof callback === "function") {
            callback();
        }
    }).fail(function(textStatus, errorThrown) {
      $(id).html('<div class="EventCritical"><p>Error - Timeout</p></div>');
    });
}

function init_gauge(css_selector)
{
  $( css_selector ).each(function(){
     var chart = bb.generate({
         bindto: "#"+$(this).attr('id'),
         data: {
             columns: [[$(this).data('label'),$(this).data('value')]],
             type:"gauge"
             },
         color: {
             pattern: ["#83BC00","#FFCB1F","#DA002E"],
             threshold: {
                 //            unit: 'value', // percentage is default
                 //            max: 200, // 100 is default
                                         values: [80,90]
                                         }
             },
         size: {
             height: 100,
             width:180,
             },
         gauge: {
             label:{
                 format: function(value, ratio){
                     return value;
                 },
             },
             min: 0,
             max: 100,
             units: "%"
         },
         legend: {
        	    show: false
        	  },
         tooltip: {
             format: {
                 value: function (value, ratio, id) {
                     var format = d3.format(',');
                     return format(value);

                 }
         }
         }
  });
  });
}

//Page Vue des Stockages
function view(key)
{
    $(key).each(function()
    {
   		if($(this).find("#default").attr('type') == 'text')
   		{
   			$(this).find("#default").attr('type', 'hidden');
   			$(this).find("#title").attr('style', 'visibility: hidden');
   			$(this).find('#advanceButton').css("background-image","url('/theme/default-image/esia_plus_button.png')");
   		}
   		else
   		{
   			if($(this).find("#default").attr('type') == 'hidden')
   			{
   				$(this).find("#default").attr('type','text');
   				$(this).find("#title").attr('style', 'visibility: visible');
   				$(this).find('#advanceButton').css("background-image","url('/theme/default-image/esia_moins_button.png')");
   			}
   		}
    });
}

function enableOrDisableCheckButton(){
    if( $("#default").val().length>0 && $('td input:checked').length>0){
        $("input[type='submit']").attr("disabled",false);
    }
    else $("input[type='submit']").attr("disabled",true);
}
function enableOrDisableCheckButton(){
    if( $("#default").val().length>0 && $('td input:checked').length>0){
        $("input[type='submit']").attr("disabled",false);
    }
    else $("input[type='submit']").attr("disabled",true);
}

function enableOrDisableAllCheckButton(){
    $("#list_storage input:checkbox:visible").prop('checked', $("#list_storage #allcheckbox").prop('checked'));
}

//Page Vue des VMs
function dialog_confirm_vm_action(css_selector,ok_text,cancel_text)
{
    $( css_selector ).dialog({
      autoOpen: false,
      resizable: false,
      height: "auto",
      width: 400,
      modal: true,
      buttons: {
        [ok_text] : function() {
            var current_url = $(this).data('url');
            var current_index = $("#tabs").tabs("option","active");
            var old_url = $("#tabs .vm-client a").attr('href');
            $("#tabs .vm-client a").attr('href',current_url);
            $( this ).dialog( "close" );

            $("#tabs").tabs('load',current_index);
            $("#tabs .vm-client a").attr('href',old_url);
        },
        [cancel_text] : function() {
          $( this ).dialog( "close" );
        }
      }
    });

    const arr = [ 'start' , 'stop' , 'restart' ];
    $.each(arr, function(index, value) {
        $( ".button-vm-"+value ).on( "click", function(event) {
             event.preventDefault();
            $( "#dialog-vm-"+value ).data( "url" , $(this) .attr('href') );
            $( "#dialog-vm-"+value ).dialog( "open" );
        });
    });
}
